/* 
   Hud.h

   SpaceShipChase 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _HUD_H_
#define _HUD_H_

#include <GL/gl.h>

#include "SDL.h"
#include "SDL_ttf.h"

/**
 * base class for hud (heads up display)
 */
class Hud
{
 public:
  Hud();
  virtual ~Hud();

  /**
   * draw the hud
   */
  virtual void draw() { };

 protected:
  /**
   * switch to 2d drawing mode
   */
  void start2DMode();
  /**
   * switch back to 3d mode
   */
  void end2DMode();

  /**
   * convert an SDL surface to a GL texture
   */
  GLuint GLLoadTexture(SDL_Surface *surface, GLfloat *texcoord);
  /**
   * helper to make the texture a power of 2
   */
  int powerOfTwo(int input);
};

#endif
