/* 
   HudInGame.h

   SpaceShipChase 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _HUDINGAME_H_
#define _HUDINGAME_H_

#include <sstream>
#include <iostream>
using namespace std;

#include "Hud.h"

/**
 * in game hud
 *  displaying time left
 */
class HudInGame : public Hud
{
 public:
  static HudInGame *getInstance();
  /**
   * draw the hud
   */
  virtual void draw();
  /**
   * update the time
   */
  virtual void update(float time);

 protected:
  // font
  TTF_Font *_font;

  // width and height of the counter in the top right
  int _counterW, _counterH;
  // coordinates for the counter
  GLfloat _counterCoordinates[4];
  // counter texture
  GLuint _counterTexture[1];
  // top left corner of counter position
  double _counterTopPosition, _counterLeftPosition;

 private:
  HudInGame();
  ~HudInGame();
};

#endif
