/* 
   HudMessage.h

   SpaceShipChase 
   Copyright (C) 2004 Marcus W Dillavou <line72@users.sf.net>
                  and Amy L Dillavou <gs2luv@users.sf.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
*/

#ifndef _HUDMESSAGE_H_
#define _HUDMESSAGE_H_

#include <iostream>
#include <string>
using namespace std;

#include "Hud.h"
#include "SystemConfig.h"
#include "Timer.h"

/**
 * display a large message
 *  for a specified time
 */
class HudMessage : public Hud
{
 public:
  static HudMessage *getInstance();
  /**
   * draw the hud
   */
  virtual void draw();
  /**
   * add a new message
   */
  void addMessage(string message, double time);

 protected:
  // font
  TTF_Font *_font;

  // width and height of the message in the top right
  int _messageW, _messageH;
  // coordinates for the message
  GLfloat _messageCoordinates[4];
  // message texture
  GLuint _messageTexture[1];
  // top left corner of message position
  double _messageTopPosition, _messageLeftPosition;

  Timer _timer;
  double _timerLength;

 private:
  HudMessage();
  virtual ~HudMessage();
};

#endif
